Page MenuHomePhabricator

Make it possible for admin to remove a mentor when they quit/are blocked
Closed, ResolvedPublic

Description

At the moment, when a mentor quits (and doesn't opt-out using the M2 module), is removed from the mentors list by someone, or is blocked (long term block), their mentees are not reassigned. They have to be claimed one by one, as they apear to be active.

To have a continuity in service, maybe activated mentees (as in mentees who made at least one edit) should be automatically reassigned. (Suggested here). If automation is not possible, we should provide a way for communities to reassign mentees en masse.

We receive requests from various communities time to time, asking us to reassign some mentees (here or there).

Related Objects

StatusSubtypeAssignedTask
ResolvedUrbanecm_WMF
ResolvedUrbanecm_WMF
ResolvedUrbanecm_WMF
ResolvedUrbanecm_WMF
ResolvedUrbanecm_WMF
ResolvedUrbanecm_WMF
ResolvedTrizek-WMF
ResolvedTrizek-WMF
DeclinedTrizek-WMF
ResolvedUrbanecm_WMF
ResolvedUrbanecm_WMF
OpenNone
ResolvedUrbanecm_WMF
ResolvedUrbanecm_WMF
ResolvedUrbanecm_WMF
OpenNone
ResolvedUrbanecm_WMF
ResolvedBUG REPORTUrbanecm_WMF
ResolvedUrbanecm_WMF
ResolvedUrbanecm_WMF
ResolvedUrbanecm_WMF
ResolvedUrbanecm_WMF
ResolvedUrbanecm_WMF
ResolvedUrbanecm_WMF
ResolvedBUG REPORTkostajh
ResolvedBUG REPORTUrbanecm_WMF
OpenUrbanecm_WMF
OpenBUG REPORTUrbanecm_WMF

Event Timeline

Restricted Application added a subscriber: Aklapper. · View Herald Transcript
Trizek-WMF renamed this task from Automatically reassign activated mentees to new mentors when their mentor quits to Automatically reassign activated mentees to new mentors when their mentor quits or is blocked.Jan 19 2021, 5:29 PM
Trizek-WMF updated the task description. (Show Details)

A long-term block seems like a very unlikely occurrence. Quitting is not, but how do you detect it? Time of last edit?
(I wonder if we should take that into account in mentor selection. Reassigning is a somewhat disruptive operation, but not assigning new mentees to the user could be done much more aggressively. E.g. don't assign to any mentors who had no edits in the last 30 days.)

Hello! The main idea why I would like to reassign mentees is that when the mentor leaves, he loses motivation. And his answers may be less friendly than we would like.

As one of the options, when you open the question form, a check is made for the presence of a mentor in the list. And if the mentor is not there, then the message "Congratulations! You have a cool new mentor" appears. And the message is already being sent to new mentor.

Hi, Vietnamese Wikipedia just had a situation where a mentor (also an admin and bureaucrat) was voted to have the adminship removed because he created thousands of articles badly translated using the Content Translation tool. After that, he's also banned for 43 days.

The current solution is to remove him from the mentor list by hand, but after he's back the community will need to discuss on whether he should be a mentor again.

Also, who will answer his mentee's questions now that he's banned?

Could we create some kind of help page with information on how to reassign mentors using a maintance script before we implemented this feature?

We just had this problem on Polish Wikipedia. A mentor does not have time to answer questions anymore and wants to quit. He removed himself from the list of mentors. But the problem is that he still gets questions.

So I think there are two main situations here:

  1. Mentor quits. He might want to re-assign his mentees to random mentors.
  2. Mentor is not active (or some other problem). Person with proper rights can do the re-assignment.

And I think the 1st can be solved in the same way as 2nd. Mentor that is still active enough to ask can simply ask a Bureaucrat to re-assign mentees. So more or less the same as when a sysop no longer want to be a sysop.

So proposed solution:

  1. Prepare a special page to randomly re-assign mentees of a specifc mentor.
  2. Bureaucrats can access this special page.
  3. There should be a confirmation with a warning. Maybe something like: "This mentor has 123 mentees. Are you sure you want to re-assign his/her menetees? This action cannot be undone!"

And unless this is not obvious 🙂... This would have to be annouced so that wikis can prepare for this. I mean some procedures might need to be developed within communities. And some info for mentors would have to be prepared by local communities.

So proposed solution:

  1. Prepare a special page to randomly re-assign mentees of a specifc mentor.
  2. Bureaucrats can access this special page.
  3. There should be a confirmation with a warning. Maybe something like: "This mentor has 123 mentees. Are you sure you want to re-assign his/her menetees? This action cannot be undone!"

I like this decision, but I think that such a right can be given not only to bureaucrats, but also to administrators. Some projects have no bureaucrats, and not all bureaucrats have the same rights in different projects.

It is also worth considering what message we will write to the participant whose mentor has changed. And where this message should appear. @Urbanecm_WMF suggests the following wording in T275972#6867023: "Your previous mentor is no longer available, so we assigned you a new one".

New case, at ar.wp: the ex-mentor doesn't want to see any mentees' questions anymore.

This module is part of the Mentor's homepage. But it should be available as a raw special page in a first time, to address the requests we had received.

This module is part of the Mentor's homepage. But it should be available as a raw special page in a first time, to address the requests we had received.

There's Special:QuitMentorship now (working only on wikis with mentor dashboard enabled). It works (tested at cs.wikipedia), but is not (intentionally) advertised anywhere (yet). Will be linked from mentor dashboard, and that's all.

Trizek-WMF renamed this task from Automatically reassign activated mentees to new mentors when their mentor quits or is blocked to Provide a way to reassign activated mentees to new mentors when their mentor quits or is blocked.EditedJan 31 2022, 3:32 PM
Trizek-WMF updated the task description. (Show Details)

renamed this task

"A way" exists, in the API, already. I don't think the "reason" why they need to be reassigned (e.g. only "quits or blocked") is that important. Design wise I suppose an important direction is: Is this something that should be run by users, or by some sort of job/trigger?

Is this something that should be run by users, or by some sort of job/trigger?

Speaking as a volunteer mentor here, I would prefer to have the reassignment being validated by someone identified, ideally through an on-wiki request.

An automatic trigger such as removing the name from the list could lead to some abuses: one could remove all names from the list as a vandalism, leading to a complete reshuffling of the mentees.

Maybe we should automatically set the mentor as away if they are removed from the list. I think we didn't do that because of vandalism concerns, which should be easier to handle with the new structured mentor page.

If this will be triggered on-wiki, perhaps [[Special:ReassignMentees]] or the like could be created, requiring (setmentor) permissions as is already on the API.

Inputs:
*Input: a username; %mentor
*Input: A log summary %logsummary
**Possible default log summary text: A new mentor has been assigned to you, replacing a mentor that is no longer active in this process.

Process:
*Fetch the list of mentees for %mentor; %mentees
*Fetch the list of all automatic mentors from the mentor list; %mentors
*For each mentee in %mentees; setmentor = to a random mentor from %mentors

This could all be accomplished client-side with scripting, but may be easier to maintain in the extension.

@Xaosflux My current plan is to do this task together with with T264343: Have a special page for mentors to sign up by creating a page Special:ManageMentors, which will let everyone view mentors (and admins to remove them), where removing will automatically trigger reassignment of mentees. https://www.mediawiki.org/wiki/User:Martin_Urbanec_(WMF)/SpecialManageMentors shows how that might look like. I'm interested to hear your thoughts about this approach.

Note that this is currently only my thinking about this project – I can't guarantee that this will happen in exactly the same way as I imagine it at this point.

Urbanecm_WMF renamed this task from Provide a way to reassign activated mentees to new mentors when their mentor quits or is blocked to Make it possible for admin to remove a mentor when they quit/are blocked.Jul 5 2022, 8:34 PM
Urbanecm_WMF changed the task status from Open to In Progress.Aug 11 2022, 11:06 AM

This is not really an epic, but I moved this to Epics in Progress, since it pretty much overlaps with T264343. Not having it in In progress helps me to orient better on the sprint board.

This is now done, with the deployment of structured mentor list. Resolving!